package com.offcn.api.tk.app;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.TestUnti.VerificationMethod;
import com.offcn.interfaces.API;
import com.offcn.process.TK;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 113.申论试卷提交做题信息接口
 * 
 * @author puhui
 *
 */
public class submitExpoundingExercise extends TK implements API {
	public String parameter;//参数集合
	
	public String user_id;//用户id
	public String item_id;//用户id
	public String orgin;//用户id
	public String orgin_id;//用户id
	public String record_id;//用户id
	public String data1;//练习册类别id

	@Override
	public void initialize(HashMap<String, Object> data) {
		if (!isProduct && data.get("CleanDB").toString().contains("Y")) {
			cleanUser_FromDB();//清除注册用户根据user_id
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		user_id = MapUtil.getParameter(parameter, "user_id").trim();
		data1 = MapUtil.getParameter(parameter, "data").trim();
		
		if ((!data1.equals("")) && data1.equals("code")) {
			data1="\"channel\": 1,\"user_id\":code,\"item_id\":code,\"orgin\":code,\"orgin_id\":code,\"record_id\":code,\"questions\":[{\"question_id\": 97835,\"question_number\": 1,\"is_hf\": 0,\"user_answer\": \"\",\"duration\": 30,\"is_signed\": 0,\"type\": 1 }]";
			
			user_id=ListUtil.getListValue(user_idList,0);
			data1 = data1.replace("\"user_id\":code", "\"user_id\":\""+ user_id + "\"");
			data1 = data1.replace("\"item_id\":code", "\"item_id\":\""+ 112 + "\"");
			data1 = data1.replace("\"orgin\":code", "\"orgin\":\""+ 1 + "\"");
			data1 = data1.replace("\"orgin_id\":code", "\"orgin_id\":\""+ 4108 + "\"");
			data1 = data1.replace("\"record_id\":code", "\"record_id\":\""+ recordId_L + "\"");
			
			parameter = parameter.replace("\"data\":code", "\"data\":{"+ data1 +"}");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		parameter = MapUtil.getValue("parameter", data);
		String sign = MapUtil.getParameter(parameter, "sign").trim();
		
		Map<String,String> m=new HashMap<String,String>();
		m.put("data", "{"+data1+"}");
		m.put("appid","tiku");
		m.put("sign", sign);
		
		Response re = RequestDataUtils.post_form_data(data,tk_token, Url,m);
//		Response re = RequestDataUtils.Post_token(data, Url, tk_token);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = StringUtils.decodeUnicode(re.asString());

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			if("接口响应成功！".equals(msg)){
			
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
